#-------------------------------------------------------
#
# $Id: Pg.pm,v 1.5 1995/06/06 04:18:05 li00357 Exp li00357 $
#
#-------------------------------------------------------


package Pg;

require Exporter;
require DynaLoader;

@ISA = qw(Exporter DynaLoader);

@EXPORT = qw(
	PQdb
	PQsetdb
	PQreset
	PQfinish
	PQexec
	PQtrace
	PQuntrace
	PQnportals
	PQpnames
	PQparray
	PQrulep
	PQntuples
	PQninstances
	PQngroups
	PQntuplesGroup
	PQninstancesGroup
	PQnfieldsGroup
	PQfnumberGroup
	PQfnameGroup
	PQftypeGroup
	PQfsizeGroup
	PQgroup
	PQgetgroup
	PQnfields
	PQfnumber
	PQfname
	PQftype
	PQfsize
	PQsametype
	PQgetvalue
	PQgetAttr
	PQgetlength
	PQclear
	PQcleanNotify
	PQnotifies_init
	PQnotifies
	PQremoveNotify
	PQappendNotify
	PQgetline
	PQputline
	PQendcopy
	PQhost
	PQport
	PQtty
	PQoption
	PQdatabase
	PQportset
	PQxactid
	PQtracep
	PQAsyncNotifyWaiting
	PQerrormsg);

bootstrap Pg;


sub doQuery {

    # we use here the "blank" - portal !

    local( $query, $array_ref  ) = @_ ;

    local( $p, $g, $n, $m, $t, $ret ) ;

    $ret = PQexec( $query ) ;
    if ( $ret eq "R" || $ret eq "E" ) { die( "$0 PQexec: $query\nret\t$ret\nerror\t" . PQerrormsg( ) ) ; }

    $p = PQparray( "blank" ) ;
    $g = PQngroups( $p ) ;
    $t = 0 ;

    for ( $k = 0; $k < $g; $k++ ) {
        $n = PQntuplesGroup( $p, $k ) ;
        $m = PQnfieldsGroup( $p, $k ) ;
        for ( $i = 0; $i < $n; $i++ ) {
            for ( $j = 0; $j < $m; $j++ ) {
                if ( 0 == $j ) {
                    $$array_ref[$i]  =        PQgetvalue( $p, $t + $i, $j ) ;
                } else {
                    $$array_ref[$i] .= "\t" . PQgetvalue( $p, $t + $i, $j ) ;
                }
            }
        }
        $t += $n ;
    }

}


1;


#-------------------------------------------------------
# EOF
#-------------------------------------------------------
